{{/*

    HTML/Canvas Rendering of BPMN Collaboration-diagram
    
    Context: dict
       "name"           - diagram name
       "diagramSource"  - diagram source in BPMN/XML-format
       "height"         - Rendering height in pixels 
       "width"          - Rendering width in pixels

    Based on:
    - https://github.com/bpmn-io/bpmn-js-examples/tree/main/pre-packaged
    - https://github.com/bpmn-io/bpmn-js-examples/tree/master/interaction

*/}}

{{ $bpmnJsStyles := resources.GetRemote "https://unpkg.com/bpmn-js@14.2.0/dist/assets/bpmn-js.css" }}
{{ $bpmnJs := resources.GetRemote "https://unpkg.com/bpmn-js@14.2.0/dist/bpmn-navigated-viewer.development.js" }}
{{ $canvasId := urlize .name }}
{{ $bpmnUtils := resources.Get "js/bpmn-utils.js" }}

<link rel="stylesheet" href="{{ $bpmnJsStyles.Permalink }}">
<script src="{{ $bpmnJs.Permalink }}"></script>
<script src="{{ $bpmnUtils.Permalink }}"></script>
<h2>{{ .name }}</h2>
<div id="{{ $canvasId }}"></div>
<script>
  var bpmnViewer = new BpmnJS({
    container: '#{{ $canvasId }}',
    height: {{ .height }},
    width: {{ .width }}
  });
  
  bpmnViewer.importXML('{{ .diagramSource }}');

  const eventBus = bpmnViewer.get('eventBus');
  eventBus.on('element.click', event => {
    const element = event.element;

    switch(element.type) {
      case 'bpmn:MessageFlow':
        businessObjectRouter(element.businessObject.name, '{{ site.BaseURL }}' + '/docs/berichten');
        break;
      default:
        console.log(element.type);
        console.log(element.businessObject.name);
    }
    
  });
</script>

{{ partial "bpmn/bpmn-msg-flow-table" .diagramSource }}